#include <png.h>

#undef tolower          /* annoying detail required for ANSI compat. */

/* --------------------------------------- */
static png_byte *pngrow = NULL;
static png_struct *png_ptr;
static png_info *info_ptr;

int pp_openfile(image_data img)
{
 int temp;
  
  else if (pp_filetype == PNG)
    {
         /* allocate the necessary structures */
     png_ptr = (png_struct *)malloc(sizeof (png_struct)); 
     if (!png_ptr)
     {
      fclose(fpout);
      exit (1);
     }

     if ( (pngrow = (png_byte *)malloc(2*img.meshsize*sizeof(png_byte)))
               == NULL) {
	     fprintf(stderr,"Memory allocation error");
	     exit(1);
           }

     info_ptr = (png_info *)malloc(sizeof (png_info));
     if (!info_ptr)
     {
      fclose(fpout);
      free(png_ptr);
      exit (1);
     }

     /* set error handling */
     if (setjmp(png_ptr->jmpbuf))
     {
      png_write_destroy(png_ptr);
      fclose(fpout);
      free(png_ptr);
      free(info_ptr);
      /* If we get here, we had a problem reading the file */
      fprintf(stderr,"Had error opening PNG file.\n");
      exit( 1);
     }

     png_info_init(info_ptr);  /* initialize the structures */
     png_write_init(png_ptr);
     png_init_io(png_ptr, fpout);     /* set up the output control */

    /* set the file information here */
     info_ptr->width = xsize;
     info_ptr->height = ysize;
     info_ptr->color_type = PNG_COLOR_TYPE_GRAY;
     info_ptr->bit_depth = 16;
     info_ptr->pixel_depth = 16;
     info_ptr->compression_type = 0;
     info_ptr->filter_type = 0;
     info_ptr->interlace_type = 0; /* non-interlaced */
     info_ptr->valid |= PNG_INFO_sBIT;     /* optional significant bit chunk */
     info_ptr->valid |= PNG_INFO_gAMA;     /* optional gamma chunk */
     info_ptr->gamma = 1.0;

     png_write_info(png_ptr, info_ptr);

    }
  return(0);
} /* end pp_openfile() */


void pp_writerow(image_data img, PTYPE *row)
{
 int i;
 int lcount = 0;      /* num. of pixels per line for PGM ascii */

  if (img.type == PNG) { 
     for(i=0;i<img.meshsize;i++) {
       unsigned int color;
       color = row[i]*MAX_PIXVAL;
       pngrow[2*i] = color >> 8;
       pngrow[2*i + 1] = color % 256;
     }
     png_write_row(png_ptr, pngrow);

} /* end pp_writerow */

int pp_closefile(image_data img)
{
  if(img.type == PNG)
    {
      png_write_end(png_ptr, info_ptr);
      png_write_destroy(png_ptr);
      free(png_ptr);
      free(info_ptr);
    }
  return(fclose(fpout));               /* close the file */
}
